//
// File:    hm_Args.h
// Author:  Marc Zinnschlag

// Klassen:
// hm_args:
//      Kommandozeilen-Argumente

#ifndef HDR_hm_Args
#define HDR_hm_Args

// C++

#ifndef LIB_string2
#include <string>
#define LIB_string2
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_args
// -----------------------------------------------------------------------------------------

using namespace std;

#include <iosfwd>

class hm_args
{
        string d_SpecPath;
        string d_LayoutPath;
        string d_Cpp;
        int d_Options;
        int d_Args;
        bool d_Ok;

    public:

        enum option
        {
            PointerAssert = 1,
            HMake = 2,
            CMake = 4,
            PureVirtual = 8,
            MakeMake = 16
        };

    public:

    // Konstruktoren

        hm_args (int argc, char *argv[]);
        ~hm_args();

    // Konstante

        bool HasArgs() const;

        bool HasOption (option Option) const;

        void ExplainOptions (ostream& Stream, const string& ToolName) const;

        bool IsOk() const;
        // Argumentliste ok?

        string GetSpecPath() const;
        string GetLayoutPath() const;
        string GetCpp() const;
};

// inline-Funktioen

inline bool hm_args::HasArgs() const { return d_Args!=0; }
inline bool hm_args::HasOption (option Option) const
{ return (d_Options & Option)!=0; }
inline bool hm_args::IsOk() const { return d_Ok; }
inline string hm_args::GetSpecPath() const { return d_SpecPath; }
inline string hm_args::GetLayoutPath() const { return d_LayoutPath; }
inline string hm_args::GetCpp() const { return d_Cpp; }

#endif
