//
// File:    hm_CMake.h
// Author:  Marc Zinnschlag

// Klassen:
// hm_cmake:
//      Erzeugung von c-Dateien

#ifndef HDR_hm_CMake
#define HDR_hm_CMake

// C++

#ifndef LIB_string2
#include <string>
#define LIB_string2
#endif

#ifndef LIB_list
#include <list>
#define LIB_list
#endif

#ifndef LIB_map
#include <map>
#define LIB_map
#endif

// HMake

#ifndef HDR_hm_Layout
#include "hm_Layout.h"
#endif

#ifndef HDR_hm_Args
#include "hm_Args.h"
#endif

#ifndef HDR_hm_Functions
#include "hm_Functions.h"
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_cmake
// -----------------------------------------------------------------------------------------

using namespace std;

#include <iosfwd>

class ul_token;
class ul_scanner;
class hm_attribute_protocol;
class hm_component;
class hm_class;

class hm_cmake
{
        const hm_layout d_Layout;
        const hm_args d_Args;
        list<hm_function> d_Inline;

    private:

    // Nicht implementiert

        hm_cmake (const hm_cmake&);
        hm_cmake& operator= (const hm_cmake&);

    // Konstante

        void SkipInstruction (ul_scanner& HFile) const;

        void SkipTitle (ul_scanner& HFile, ostream& CFile) const;

        void ReadTemplate (ul_scanner& HFile, list<ul_token>& Template) const;

    // Nicht-Konstante

        bool MakeComponent (const list<hm_component>& Components,
            const hm_component& Component,
            const list<hm_attribute_protocol *>& Attributes);
        // Return: Ok?

        void H2C (ostream& Out, ul_scanner& In, int& NestingCount, const string& Class,
            map<string, string> Types, const list<ul_token>& Template);
        // Types: typedefs und enums (first) mit Klassenangaben (second)

    // Statische

        static void WriteTokens (const list<ul_token>::const_iterator& Begin,
            const list<ul_token>::const_iterator& End, ostream& CFile);

    public:

    // Konstruktoren

        hm_cmake (const hm_layout& Layout, const hm_args& Args);
        ~hm_cmake();

    // Nicht-Konstante

        bool Make (const list<hm_component>& Components,
            const list<hm_attribute_protocol *>& Attributes);
        // Return: Ok?
};

#endif
