//
// File:    hm_Class.c++
// Author:  Marc Zinnschlag

#ifndef HDR_hm_Class
#include "hm_Class.h"
#endif

// C

#ifndef LIB_cassert
#include <cassert>
#define LIB_cassert
#endif

// C++

#ifndef LIB_algorithm
#include <algorithm>
#define LIB_algorithm
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_class
// -----------------------------------------------------------------------------------------

// Konstruktoren ---------------------------------------------------------------------------

hm_class::hm_class (const string& Name) : d_Name (Name)
{
    assert (!Name.empty());
}

hm_class::~hm_class() {}

// Konstante -------------------------------------------------------------------------------

bool hm_class::HasAttribute (const string& Attr) const
{
    return find (d_Attributes.begin(), d_Attributes.end(), Attr)!=d_Attributes.end();
}

// Nicht-Konstante -------------------------------------------------------------------------

// Der Klasse das angegebene Attribut zuordnen
// Es wird nicht berprft Attr ein gltiges Attribut ist
// Das mehrfache Zuordnen desselben Attributes ist zulssig

void hm_class::AddAttribute (const string& Attr)
{
    assert (!Attr.empty());
    d_Attributes.push_back (Attr);
}
