//
// File:    hm_Class.h
// Author:  Marc Zinnschlag

// Klassen:
// hm_class:
//      Beschreibung einer benutzerdefinierten Klasse

#ifndef HDR_hm_Class
#define HDR_hm_Class

// C++

#ifndef LIB_string2
#include <string>
#define LIB_string2
#endif

#ifndef LIB_list
#include <list>
#define LIB_list
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_class
// -----------------------------------------------------------------------------------------

using namespace std;

class hm_class
{
        string d_Name;
        list<string> d_Attributes;

    public:

    // Konstruktoren

        hm_class (const string& Name);
        ~hm_class();

    // Konstante

        string GetName() const;

        bool HasAttribute (const string& Attr) const;

    // Nicht-Konstante

        void AddAttribute (const string& Attr);
        // Der Klasse das angegebene Attribut zuordnen
        // Es wird nicht berprft Attr ein gltiges Attribut ist
        // Das mehrfache Zuordnen desselben Attributes ist zulssig
};

// Freie Operatoren

bool operator== (const hm_class& Left, const hm_class& Right);
bool operator!= (const hm_class& Left, const hm_class& Right);

// inline-Funktionen

inline string hm_class::GetName() const { return d_Name; }
inline bool operator== (const hm_class& Left, const hm_class& Right)
{ return Left.GetName()==Right.GetName(); }
inline bool operator!= (const hm_class& Left, const hm_class& Right)
{ return !(Left==Right); }

#endif
