//
// File:    hm_ClassMake.h
// Author:  Marc Zinnschlag

// Klassen:
// hm_class_make:
//      Erzeugung einer Klasse (h-File)

#ifndef HDR_hm_ClassMake
#define HDR_hm_ClassMake

// C++

#ifndef LIB_string2
#include <string>
#define LIB_string2
#endif

#ifndef LIB_list
#include <list>
#define LIB_list
#endif

// HMake

#ifndef HDR_hm_Layout
#include "hm_Layout.h"
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_class_make
// -----------------------------------------------------------------------------------------

using namespace std;

#include <iosfwd>

class hm_layout;
class hm_class;
class hm_output;
class hm_attribute_protocol;

class hm_class_make
{
        list<hm_output> d_Output;
        list<hm_output> d_OutputOutside;
        hm_layout d_Layout;
        string d_Class;

    private:

    // Nicht implementiert

        hm_class_make (const hm_class_make&);
        hm_class_make& operator= (const hm_class_make&);

    // Nicht-Konstante

        void AddOutput (hm_layout::access Access, char Id, const hm_class& Class,
            const list<hm_attribute_protocol *>& Attributes, bool Outside);

    public:

    // Konstruktoren

        hm_class_make (const hm_layout& Layout, const hm_class& Class,
            const list<hm_attribute_protocol *>& Attributes);
        ~hm_class_make();

    // Konstante

        void Write (ostream& Stream) const;
        // Klasse in Stream schreiben
};

#endif
