//
// File:    hm_Components.h
// Author:  Marc Zinnschlag

// Klassen:
// hm_components:
//      Komponenten-Struktur (aus Spec-File gelesen)

#ifndef HDR_hm_Components
#define HDR_hm_Components

// C++

#ifndef LIB_string2
#include <string>
#define LIB_string2
#endif

#ifndef LIB_list
#include <list>
#define LIB_list
#endif

// HMake

#ifndef HDR_hm_Component
#include "hm_Component.h"
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_components
// -----------------------------------------------------------------------------------------

using namespace std;

class hm_components
{
        list<hm_component> d_Components;
        bool d_Errors;

    private:

    // Nicht implementiert

        hm_components (const hm_components&);
        hm_components& operator= (const hm_components&);

    // Nicht-Konstante

        void Scan (istream& Stream, const list<string>& Attributes,
            list<hm_class>& Classes);
        // Spec-Datei auswerten

        void IdentifyClasses (list<hm_class>& Classes);
        // Klassenangaben in gelesener Spec-Datei identifizieren

    // Statische

        static void CheckClasses (const list<hm_class>& Classes);
        // Auf ungenutzte Klassen prfen

    public:

    // Konstruktoren

        hm_components (istream& Stream, const list<string>& Attributes);
        // Stream: Spec-Datei

    // Konstante

        bool HadErrors() const;
        // Fehler in Spec-Datei?

        const list<hm_component>& GetComponents() const;

    // Nicht-Konstante

        list<hm_component>& GetComponents();
};

// inline-Funktionen

inline bool hm_components::HadErrors() const { return d_Errors; }
inline const list<hm_component>& hm_components::GetComponents() const
{ return d_Components; }
inline list<hm_component>& hm_components::GetComponents() { return d_Components; }

#endif
