//
// File:    hm_Default.h
// Author:  Marc Zinnschlag

// Klassen:
// hm_default_attributes:
//      Default-Attribute (copy, nocopy, assign, noassign, compare, fullcomapre, stream,
//      opX)

#ifndef HDR_hm_Default
#define HDR_hm_Default

// HMake

#ifndef HDR_hm_Attribute
#include "hm_Attribute.h"
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_default_attributes
// -----------------------------------------------------------------------------------------

using namespace std;

class hm_default_attributes : public hm_attribute_protocol
{
    private:

    // Nicht implementiert

        hm_default_attributes (const hm_default_attributes&);
        hm_default_attributes& operator= (const hm_default_attributes&);

    public:

    // Konstruktoren

        hm_default_attributes();
        virtual ~hm_default_attributes();

    // Konstante

        virtual void WriteAttributes (list<string>& Attributes) const;
        // Bekannte Attribute eintragen

        virtual void WriteIncludes (const hm_class& Class, list<string>& Includes) const;
        // Zu inkludende h-files eintragen

        virtual void WriteNotImp (const hm_class& Class, hm_output_protocol& Output) const;
        // Nicht zu implementierende Funktionen (z.B. Copy-Konstruktor oder Zuweisung)

        virtual void WriteFree (const hm_class& Class, hm_output_protocol& Output) const;
        // Freie Funktionen

        virtual void WriteInline (const hm_class& Class, hm_output_protocol& Output) const;
        // inline-Funktionen

        virtual void WritePubCon (const hm_class& Class, hm_output_protocol& Output) const;
        // Konstruktoren; public

        virtual void WritePubMani (const hm_class& Class, hm_output_protocol& Output) const;
        // Nicht-Konstante Funktionen; public
};

#endif
