//
// File:    hm_MakeMake.h
// Author:  Marc Zinnschlag

// Klassen:
// hm_makemake:
//      Erzeugung eines Make-Files

#ifndef HDR_hm_MakeMake
#define HDR_hm_MakeMake

// C++

#ifndef LIB_string2
#include <string>
#define LIB_string2
#endif

#ifndef LIB_fstream
#include <fstream>
#define LIB_fstream
#endif

#ifndef LIB_vector
#include <vector>
#define LIB_vector
#endif

// HMake

#ifndef HDR_hm_Args
#include "hm_Args.h"
#endif

// -----------------------------------------------------------------------------------------
// Klasse: hm_makemake
// -----------------------------------------------------------------------------------------

using namespace std;

#include <iosfwd>

class hm_components;
class hm_component;
class le_binary_matrix;

class hm_makemake
{
        hm_args d_Args;
        ostream *d_Makefile;
        le_binary_matrix *d_Include;
        vector<hm_component> d_Components;
	string d_Clean;

    private:

    // Nicht implementiert

        hm_makemake (const hm_makemake&);
        hm_makemake& operator= (const hm_makemake&);

    // Konstante

        int GetIndex (const string& Name) const;
        // -1: nicht vorhanden

    // Nicht-Konstante

        void CreateFile (const string& MakePath);

        void WriteMacros();

        void BuildIncludeMatrix();

        void WriteFinalTarget();

        void WriteTarget (int Index);

        void WriteSuffixes();

        void Finish (const string& MakePath);

    public:

    // Konstruktoren

        hm_makemake (const hm_args& Args);
        ~hm_makemake();

    // Nicht-Konstante

        bool Make (const hm_components& Components);
        // Return: Ok?
};

#endif
